unit uGenerarFacturasProvUtils;

interface

uses
 Windows, SysUtils, Classes, uBizAlbaranesProveedor, pngimage, JSDialog;

type
  TdmGenerarFacturasProv = class(TDataModule)
    JsListaFacturasGeneradas: TJSDialog;
  end;

  function GenerarFacturaProv(const IDAlbaran : Integer) : Boolean; overload;
  function GenerarFacturaProv(AAlbaranes : IBizAlbaranProveedor) : Boolean; overload;
  function GenerarFacturaProv : Boolean; overload;

implementation

{$R *.dfm}

uses
  uDialogUtils,
  uBizDetallesAlbaranProveedor,
  uAlbaranesProveedorController, uDetallesAlbaranProveedorController,
  uFacturasProveedorController, uBizFacturasProveedor, uBizDetallesFacturaProveedor;

//  ,
//  , uProveedoresController,
//  , uControllerDetallesBase,


//  , uBizContactos, schPedidosClienteClient_Intf,
//  schAlbaranesProveedorClient_Intf;

var
  dmGenerarFacturasProv: TdmGenerarFacturasProv;
  AAlbaranesProveedorController : IAlbaranesProveedorController;
  ADetallesAlbaranesProveedorController : IDetallesAlbaranProveedorController;
  AFacturasProveedorController : IFacturasProveedorController;
//  AProveedoresController : IProveedoresController;

{ Métodos auxiliares }
{procedure CopiarPedidoAAlbaran(APedido: IBizPedidoCliente;
  AAlbaran : IBizFacturaProveedor);
begin
  if not Assigned(AAlbaran) then
    raise Exception.Create ('Albarán no asignado (CopiarPedidoAAlbaran)');

  if not Assigned(APedido) then
    raise Exception.Create ('Pedido no asignado (CopiarPedidoAAlbaran)');

  if not APedido.DataTable.Active then
    APedido.DataTable.Active := True;

  // El albarán tiene que venir ya abierto y posicionado donde hay que copiar
  AAlbaran.ID_CLIENTE := APedido.ID_CLIENTE;
  AAlbaran.ID_PEDIDO := APedido.ID;
  AAlbaran.CALLE := APedido.CALLE;
  AAlbaran.CODIGO_POSTAL := APedido.CODIGO_POSTAL;
  AAlbaran.POBLACION := APedido.POBLACION;
  AAlbaran.PROVINCIA := APedido.PROVINCIA;
  AAlbaran.PERSONA_CONTACTO := APedido.PERSONA_CONTACTO;
  AAlbaran.TELEFONO := APedido.TELEFONO;
  AAlbaran.IMPORTE_NETO := APedido.IMPORTE_NETO;
  AAlbaran.IMPORTE_PORTE := APedido.IMPORTE_PORTE;
  AAlbaran.DESCUENTO := APedido.DESCUENTO;
  AAlbaran.IMPORTE_DESCUENTO := APedido.IMPORTE_DESCUENTO;
  AAlbaran.BASE_IMPONIBLE := APedido.BASE_IMPONIBLE;
  AAlbaran.IVA := APedido.IVA;
  AAlbaran.IMPORTE_IVA := APedido.IMPORTE_IVA;
  AAlbaran.IMPORTE_TOTAL := APedido.IMPORTE_TOTAL;
  AAlbaran.DataTable.FieldByName(fld_AlbaranesClienteOBSERVACIONES).AsVariant := APedido.DataTable.FieldByName(fld_PedidosClienteOBSERVACIONES).AsVariant;
  AAlbaran.ID_FORMA_PAGO := APedido.ID_FORMA_PAGO;
end;

procedure CopiarArticulosPendAAlbaran(
  APedido: IBizPedidoCliente;
  AAlbaran: IBizFacturaProveedor;
  AArticulosPendientes: IBizPedidoClienteArticulosPend);
var
  i : integer;
  ADetalles : IBizDetallesFacturaProveedor;
  ADetallesController : IDetallesFacturaProveedorController;
begin
  if not Assigned(AAlbaran) then
    raise Exception.Create ('Albarán no asignado (CopiarArticulosPendAAlbaran)');

  if not Assigned(APedido) then
    raise Exception.Create ('Pedido no asignado (CopiarArticulosPendAAlbaran)');

  if not Assigned(AArticulosPendientes) then
    raise Exception.Create ('Artículos pendientes no asignado (CopiarArticulosPendAAlbaran)');

  if not AArticulosPendientes.DataTable.Active then
    AArticulosPendientes.DataTable.Active := True;

  // El albarán tiene que venir ya abierto y posicionado donde hay que copiar

  ADetalles := AAlbaran.Detalles;
  ADetallesController := TDetallesFacturaProveedorController.Create;
  try
    AArticulosPendientes.DataTable.First;
    for i := 0 to AArticulosPendientes.DataTable.RecordCount - 1 do
    begin
      APedido.Detalles.First;
      if (APedido.Detalles.Locate('ID_ARTICULO', AArticulosPendientes.ID_ARTICULO, [])) then
        if (AArticulosPendientes.CANTIDAD_PENDIENTE > 0) then
        begin
          ADetallesController.Add(ADetalles, TIPO_DETALLE_CONCEPTO);
          ADetalles.Edit;
          ADetalles.REFERENCIA := APedido.Detalles.REFERENCIA;
          ADetalles.ID_ARTICULO := APedido.Detalles.ID_ARTICULO;
          ADetalles.CONCEPTO := APedido.Detalles.CONCEPTO;
          ADetalles.CANTIDAD := AArticulosPendientes.CANTIDAD_PENDIENTE;
          ADetalles.IMPORTE_UNIDAD := APedido.Detalles.IMPORTE_UNIDAD;
          ADetalles.IMPORTE_TOTAL := APedido.Detalles.IMPORTE_TOTAL;
          ADetalles.DESCUENTO := APedido.Detalles.DESCUENTO;
          ADetalles.IMPORTE_PORTE := APedido.Detalles.IMPORTE_PORTE;
          ADetalles.VISIBLE := APedido.Detalles.VISIBLE;
          ADetalles.REFERENCIA_PROVEEDOR := APedido.Detalles.REFERENCIA_PROVEEDOR;
          ADetalles.Post;
          AArticulosPendientes.Next;
        end;
    end;
  finally
    ADetallesController := NIL;
  end;
end;  }

procedure Inicializar;
begin
  dmGenerarFacturasProv := TdmGenerarFacturasProv.Create(nil);
  AAlbaranesProveedorController := TAlbaranesProveedorController.Create;
  ADetallesAlbaranesProveedorController := TDetallesAlbaranProveedorController.Create;
  AFacturasProveedorController := TFacturasProveedorController.Create;
//  AProveedoresController := TProveedoresController.Create;
end;

procedure Finalizar;
begin
  FreeAndNIL(dmGenerarFacturasProv);
  AAlbaranesProveedorController := nil;
  ADetallesAlbaranesProveedorController := nil;
  AFacturasProveedorController := nil;
//  AProveedoresController := nil;
end;


function GenerarFacturaProv(const IDAlbaran : Integer) : Boolean; overload;
var
  AAlbaran : IBizAlbaranProveedor;
begin
  Result := False;
  if not Assigned(AAlbaranesProveedorController) then
     Inicializar;

  AAlbaran := AAlbaranesProveedorController.Buscar(IDAlbaran);
  Result := GenerarFacturaProv(AAlbaran);

  if Assigned(AAlbaranesProveedorController) then
     Finalizar;
end;

function GenerarFacturaProv(AAlbaranes : IBizAlbaranProveedor) : Boolean; overload;
var
  ARespuesta : Integer;
  AFacturasNuevas : IBizFacturaProveedor;
//  AArticulos: IBizPedidoClienteArticulosPend;
  i: Integer;
begin
  Result := False;
  if not Assigned(AAlbaranesProveedorController) then
     Inicializar;

  if not Assigned(AAlbaranes) then
     raise Exception.Create('Albarán de proveedor no asignado (GenerarFacturaProv)');

  if not AAlbaranes.DataTable.Active then
     AAlbaranes.DataTable.Active := True;

  try
     AFacturasNuevas := AFacturasProveedorController.Nuevo;
     if AFacturasProveedorController.Anadir(AFacturasNuevas, AAlbaranes) then
     begin
       if AFacturasNuevas.DataTable.RecordCount = 1 then
          AFacturasProveedorController.Ver(AFacturasNuevas)
       else begin
          with dmGenerarFacturasProv.JsListaFacturasGeneradas.Content do
          begin
            Clear;
            AFacturasNuevas.DataTable.Last;
            for i := 0 to AFacturasNuevas.DataTable.RecordCount - 1 do
            begin
              if Length(AFacturasNuevas.REFERENCIA) > 0 then
                  Add(AFacturasNuevas.REFERENCIA + ': ' + AFacturasNuevas.NOMBRE);
              AFacturasNuevas.DataTable.Prior;
            end;
          end;
          dmGenerarFacturasProv.JsListaFacturasGeneradas.Execute;
        end;
//          actRefrescar.Execute;
      end;
   finally
     AFacturasNuevas := NIL;
   end;
end;

function GenerarFacturaProv : Boolean; overload;
var
  AAlbaranes : IBizAlbaranProveedor;
begin
  Result := False;
  if not Assigned(AAlbaranesProveedorController) then
     Inicializar;

  AAlbaranes := AAlbaranesProveedorController.ElegirAlbaranes(AAlbaranesProveedorController.BuscarSinFacturar,
                'Elija el albarán o albaranes de proveedor que desea utilizar para dar de alta la factura.'
                + #10#13 + 'Si elige albaranes de proveedores diferentes se dará de alta una factura por cada uno de ellos.' , True);

  Result := GenerarFacturaProv(AAlbaranes);

  if Assigned(AAlbaranesProveedorController) then
     Finalizar;
end;

end.
